
// ---

var header_spy = {

    options : null,

    // will be updated on tab change
    headers_request  : {"None" : "None"},
    headers_response : {"None" : "None"},

    get_controller: function(theDocument) {
        var controller = null;

        if (theDocument && 'defaultView' in theDocument && 'controllers' in theDocument.defaultView) {
            var controllers = theDocument.defaultView.controllers;
            while (controllers.wrappedJSObject) controllers = controllers.wrappedJSObject;
            controller = controllers.getControllerForCommand('livehttpheaders');

            // The controller might be wrapped multiple times
            while (controller && !('headers' in controller)) controller = controller.wrappedJSObject;
        }

        return controller;
    },

    get_headers_request: function(controller) {
        var headers = [];
        for (i in controller.headers.requestHeaders) {
            headers[i] = controller.headers.requestHeaders[i];
        }
        headers["REQUEST"] = controller.headers.request;
        return headers;
    },

    get_headers_response: function(controller) {
        var headers = [];
        for (i in controller.headers.responseHeaders) {
            headers[i] = controller.headers.responseHeaders[i];
        }
        //for (i in headers.responseHeaders) {
        //  // Server can send some headers multiple times...  
        //  // Try to detect this and present them in the 'good' way.
        //  var multi = headers.responseHeaders[i].split('\n');
        //  for (var o in multi) {
        //   responseheaders.addRow([i, multi[o]]);
        //  }
        //}
        headers["RESPONSE"] = controller.headers.response;
        return headers;
    },

    tooltip_init: function(i) {
        var vbx = document.getElementById(this.options.panels[i].sbp_tooltip);
        if (vbx) {
            vbx = vbx.firstChild;
            while (vbx.firstChild) vbx.removeChild(vbx.firstChild); // clear list
        }
        return vbx;
    },

    tooltip: function(vbx, headers, i, _title, _popup_headers) {
        var v_header = [];
        var v_value = [];

        // --- gather

        ph_array = _popup_headers.split(' ');
        for (var ph in ph_array) {
            var header_name = ph_array[ph];
            var header_value = headers[header_name];

            if (header_name.length == 0) break;
            else if (header_value == null) {
                if (this.options.panels[i].popup_headers.show_if_exist) continue;
                else header_value = header_spy_options_store.defaults.status;
            }

            // Server can send some headers multiple times...  
            // Try to detect this and present them in the 'good' way.
            var multi = header_value.split('\n');
            for (var o in multi) {
                v_header.push(header_name);
                v_value.push(multi[o]);
            }
        }

        var egroupbox, evbox_names, evbox_values, ename, evalue;
        if (v_header.length == 0) {
//        ename = document.createElement('label');
//        ename.setAttribute('value', "No values for headers: " + _popup_headers);//this.getStr('cookiesafe.Allowed'));
//        vbx.appendChild(ename);
        } else {
            evbox_names  = document.createElement('vbox');
            evbox_values = document.createElement('vbox');

            var wrap_on = this.options.panels[i].popup_headers.wrap_on;
            for (j in v_header) {
                var sh = v_header[j], sv, svrest = v_value[j];
                for ( ; ; ) {
                    if (wrap_on <= 0) { // don't wrap
                        sv = svrest;
                        svrest = "";
                    } else {
                        sv = svrest.substring(0, wrap_on);
                        svrest = svrest.substring(wrap_on);
                    }

                    ename = document.createElement('label');
                    ename.setAttribute('value', sh);
                    ename.setAttribute('style', 'font-weight: 900;');
                    evbox_names.appendChild(ename);

                    evalue = document.createElement('label');
                    //evalue.setAttribute('style', 'width: 500px;');
                    evalue.setAttribute('crop', 'right');
                    evalue.setAttribute('value', sv);
                    evbox_values.appendChild(evalue);

                    if (0 == svrest.length) break; // no more to show
                    sh = null; // don't show header on wrapped lines
                }
            }

            evalue = document.createElement('hbox');
            evalue.appendChild(evbox_names);
            evalue.appendChild(evbox_values);

            ename = document.createElement('caption');
            ename.setAttribute('label', _title);

            egroupbox = document.createElement('groupbox');
            egroupbox.appendChild(ename);
            egroupbox.appendChild(evalue);

            vbx.appendChild(egroupbox);
        }

        return v_header.length;
    },

    rebuild: function(aWebProgress) {
        var do_clear = true;
        
        if (aWebProgress != null
                && !aWebProgress.isLoadingDocument
                && 'document' in aWebProgress
                ) {
            var controller = this.get_controller(aWebProgress.document);
            if (controller) {
                do_clear = false; // don't touch states
                this.headers_request  = this.get_headers_request(controller);
                this.headers_response = this.get_headers_response(controller);

                for (i = 0 ; i < this.options.panels.length ; i++) {
                    var value = this.options.panels[i].header;
                    value = (0 == this.options.panels[i].headersrc ? this.headers_request[value] : this.headers_response[value]);
                    this.options.panels[i].current_status = value ? value : header_spy_options_store.defaults.status;
                    // this.create_tooltip(i);
                }
            }
/*
        } else if (aWebProgress != null
                && aWebProgress.isLoadingDocument
                && 0 == this.headers_request.length
                ) {
            return; // do nothing on progress
*/
        } else {
            this.headers_request  = [];
            this.headers_response = [];
        }

        if (do_clear) { // reset states
            for (i = 0 ; i < this.options.panels.length ; i++) {
                this.options.panels[i].current_status = header_spy_options_store.defaults.status;
            }
        }

        for (i = 0 ; i < this.options.panels.length ; i++) {
            var el_status = document.getElementById(this.options.panels[i].sbp_name);
            if (!el_status) continue;

            el_status.crop = "end";
            el_status.maxWidth = this.options.panels[i].max_width;

            el_status.label = this.options.panels[i].show_name
                ? (this.options.panels[i].header + ": " + this.options.panels[i].current_status)
                : this.options.panels[i].current_status;
            el_status.collapsed = (
                this.options.panels[i].current_status == header_spy_options_store.defaults.status
                && this.options.panels[i].show_if_exist
                );
        }
    },
    	
    full_view: function(i) {
        if (null == i) i = 0;
        var el_status = document.getElementById(this.options.panels[i].sbp_name);

        if (el_status.maxWidth == header_spy_options_store.defaults.max_expand_width) {
            el_status.maxWidth = this.options.panels[i].max_width;
        } else {
            el_status.maxWidth = header_spy_options_store.defaults.max_expand_width;
        }
        el_status.collapsed = false;
    },

    create_tooltip: function(i) {
        if (null == i) i = 0;

        var vbx = this.tooltip_init(i);
        if (vbx) {
            var ttcnt = this.tooltip(vbx, this.headers_request,  i, "Request",  this.options.panels[i].popup_headers.request);
            ttcnt += this.tooltip(vbx, this.headers_response, i, "Response", this.options.panels[i].popup_headers.response);

            if (0 == ttcnt) { // there is no valid headers to show. We need to show default tooltip
                var el_status = document.getElementById(this.options.panels[i].sbp_name);
                if (el_status) {
                    var ename = document.createElement('label');
                    ename.setAttribute('value', el_status.label);
                    vbx.appendChild(ename);
                }
            }
        }
    }
};

// ---

/*
eval('gBrowser.addTab =' + getBrowser().addTab.toString().replace(
    'if (!blank) {',
    'for (i = 0 ; i < header_spy.options.panels.length ; i++) { document.getElementById(header_spy.options.panels[i].sbp_name).collapsed = blank; } \
         if (!blank) {'
    )
);
*/
///*
eval('gBrowser.addTab =' + getBrowser().addTab.toString().replace(
    'if (!blank) {',
    'if (blank) header_spy.rebuild(null); if (!blank) {'
    )
);
//*/

var header_spy_prefs_observer = {
    observe: function (aSubject, aTopic, aState) 
    {
        if (aTopic == "header-spy-load-prefs") {
            header_spy.options = header_spy_options_store.get();

            for (i = 0 ; i < header_spy.options.panels.length ; i++) {
                var el_status = document.getElementById(header_spy.options.panels[i].sbp_name);
                if (!el_status) continue;
                
                el_status.crop = "end";
                el_status.maxWidth = header_spy.options.panels[i].max_width;
            }
            for ( ; ; i++) {
                var el_status = document.getElementById(header_spy.options.panels[i].sbp_name);
                if (!el_status) break;

                el_status.collapsed = true; // collapse unused panels
            }
        }
    },
};

HEADER_SPY_OBSERV_SERVICE.addObserver(header_spy_prefs_observer,     "header-spy-load-prefs", false);
HEADER_SPY_OBSERV_SERVICE.notifyObservers(header_spy_prefs_observer, "header-spy-load-prefs", false);

// ---

const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP  = Components.interfaces.nsIWebProgressListener.STATE_STOP;

function header_spy_register_ASL()
{
    header_adv_status_listener.init();
    window.getBrowser().addProgressListener(header_adv_status_listener, STATE_START);
}

function header_spy_unregister_ASL()
{
    header_adv_status_listener.destroy();
    window.getBrowser().removeProgressListener(header_adv_status_listener, STATE_STOP);
}


window.addEventListener("load", header_spy_register_ASL,false);
window.addEventListener("unload", header_spy_unregister_ASL,false);

var header_adv_status_listener =
{
    QueryInterface: function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsIXULBrowserWindow) ||
          aIID.equals(Components.interfaces.nsISupports) ||
          aIID.equals(Components.interfaces.nsIHttpNotify) ||
          aIID.equals(Components.interfaces.nsIObserver))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },
  
    init: function() {
    },
  
    destroy: function() {
    },
  
    onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
        if (aStateFlags & STATE_START) {
            // this.el_status.crop = "end";
            // this.el_status.maxWidth = header_spy_maxWidths;
        } else if (aStateFlags & STATE_STOP) {
            header_spy.rebuild(aWebProgress);
        }
    },
  
    onProgressChange: function (a, b, c, d, e, f) {
    },
    
    onLocationChange: function(a, b, c) {
        header_spy.rebuild(a);
        window.XULBrowserWindow.onLocationChange(a, b, c);
    },

    onStatusChange: function(a, b, c, d) {
    },
    onSecurityChange: function(a, b, c) {
    },
    onLinkIconAvailable: function(a) {
    }
};

